/*
 * Java-Gnome Bindings Library
 *
 * Copyright 1998-2002 the Java-Gnome Team, all rights reserved.
 *
 * The Java-Gnome Team Members:
 *   Jean Van Wyk <jeanvanwyk@iname.com>
 *   Jeffrey S. Morgan <jeffrey.morgan@bristolwest.com>
 *   Dan Bornstein <danfuzz@milk.com>
 *
 * The Java-Gnome bindings library is free software distributed under
 * the terms of the GNU Library General Public License version 2.
 *
 * This file was orriginally generated by the Java-GNOME Code Generator
 * Please do not modify the code that is identified as generated.  Also,
 * please insert your code above the generated code.
 *
 * Generation date: 2002-08-02 09:42:26 EDT
 */

#include <jni.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <jg_jnu.h>
#include "gtk_java.h"

#include "org_gnu_gtk_TreeModelSort.h"
#ifdef __cplusplus
extern "C" 
{
#endif

static jobject getTreePath(JNIEnv* env, GtkTreePath* path)
{
	return getGBoxedHandle(env, path, GTK_TYPE_TREE_PATH,
			NULL, (GBoxedFreeFunc) gtk_tree_path_free);	
}
/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_get_type
 * Signature: ()Lorg/gnu/glib/Handle
 */
JNIEXPORT jint JNICALL Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1get_1type
		(JNIEnv *env, jclass cls) 
{
    return (jint) gtk_tree_model_sort_get_type();
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_new_with_model
 * Signature: (Lorg/gnu/glib/Handle;)Lorg/gnu/glib/Handle
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1new_1with_1model (JNIEnv *env, jclass cls, jobject childModel) 
{
    GtkTreeModel *childModel_g = 
        (GtkTreeModel *)getPointerFromHandle(env, childModel);
    return getGObjectHandle(env, (GObject *) gtk_tree_model_sort_new_with_model( childModel_g ));
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_get_model
 * Signature: (Lorg/gnu/glib/Handle;)Lorg/gnu/glib/Handle
 */
JNIEXPORT jobject JNICALL Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1get_1model (JNIEnv *env, jclass cls, jobject treeModel) 
{
    GtkTreeModelSort *treeModel_g = 
        (GtkTreeModelSort *)getPointerFromHandle(env, treeModel);
    return getGObjectHandle(env, (GObject *) gtk_tree_model_sort_get_model( treeModel_g ));
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_convert_child_path_to_path
 * Signature: (Lorg/gnu/glib/Handle;Lorg/gnu/glib/Handle;)Lorg/gnu/glib/Handle
 */
JNIEXPORT jobject JNICALL 
Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1convert_1child_1path_1to_1path (JNIEnv *env, jclass cls, jobject treeModel, jobject childPath) 
{
	GtkTreePath *path;
    GtkTreeModelSort *treeModel_g = 
        (GtkTreeModelSort*)getPointerFromHandle(env, treeModel);
    GtkTreePath *childPath_g = 
        (GtkTreePath*)getPointerFromHandle(env, childPath);
    path = gtk_tree_model_sort_convert_child_path_to_path(treeModel_g, childPath_g);
    return getTreePath(env, path);
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_convert_child_iter_to_iter
 * Signature: (Lorg/gnu/glib/Handle;Lorg/gnu/glib/Handle;Lorg/gnu/glib/Handle;)V
 */
JNIEXPORT void JNICALL 
Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1convert_1child_1iter_1to_1iter (JNIEnv *env, jclass cls, jobject treeModel, jobject childIter, jobject sortIter) 
{
    GtkTreeModelSort *treeModel_g = 
        (GtkTreeModelSort *)getPointerFromHandle(env, treeModel);
    GtkTreeIter *sortIter_g = 
        (GtkTreeIter *)getPointerFromHandle(env, sortIter);
    GtkTreeIter *childIter_g = 
        (GtkTreeIter *)getPointerFromHandle(env, childIter);

    gtk_tree_model_sort_convert_child_iter_to_iter( treeModel_g, 
                                                    sortIter_g, childIter_g );
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_convert_path_to_child_path
 * Signature: (Lorg/gnu/glib/Handle;Lorg/gnu/glib/Handle;)Lorg/gnu/glib/Handle
 */
JNIEXPORT jobject JNICALL 
Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1convert_1path_1to_1child_1path (JNIEnv *env, jclass cls, jobject treeModel, jobject sortedPath) 
{
	GtkTreePath *path;
    GtkTreeModelSort *treeModel_g = 
        (GtkTreeModelSort *)getPointerFromHandle(env, treeModel);
    GtkTreePath *sortedPath_g = 
        (GtkTreePath *)getPointerFromHandle(env, sortedPath);
	path = gtk_tree_model_sort_convert_path_to_child_path(treeModel_g, sortedPath_g);
    return getTreePath(env, path);
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_convert_iter_to_child_iter
 * Signature: (Lorg/gnu/glib/Handle;Lorg/gnu/glib/Handle;Lorg/gnu/glib/Handle;)V
 */
JNIEXPORT void JNICALL 
Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1convert_1iter_1to_1child_1iter (JNIEnv *env, jclass cls, jobject treeModel, jobject childIter, jobject sortedIter) 
{
    GtkTreeModelSort *treeModel_g = 
        (GtkTreeModelSort *)getPointerFromHandle(env, treeModel);
    GtkTreeIter *childIter_g = 
        (GtkTreeIter *)getPointerFromHandle(env, childIter);
    GtkTreeIter *sortedIter_g = 
        (GtkTreeIter *)getPointerFromHandle(env, sortedIter);

    gtk_tree_model_sort_convert_iter_to_child_iter(treeModel_g, 
                                                   childIter_g, sortedIter_g);
}

/*
 * Class:     org.gnu.gtk.TreeModelSort
 * Method:    gtk_tree_model_sort_clear_cache
 * Signature: (Lorg/gnu/glib/Handle;)V
 */
JNIEXPORT void JNICALL Java_org_gnu_gtk_TreeModelSort_gtk_1tree_1model_1sort_1clear_1cache (JNIEnv *env, jclass cls, jobject treeModel) 
{
    GtkTreeModelSort *treeModel_g = 
        (GtkTreeModelSort *)getPointerFromHandle(env, treeModel);

    gtk_tree_model_sort_clear_cache(treeModel_g);
}

#ifdef __cplusplus
}

#endif
